Package com.io7m.jregions.core.unparameterized.areas

# Class AreaXYSplitBD<T extends AreaBDType>

java.lang.Object
com.io7m.jregions.core.unparameterized.areas.AreaXYSplitBD<T>

Type Parameters:
  `T` - The precise type of area

All Implemented Interfaces:
  `AreaXYSplitBDType<T>`

public final class AreaXYSplitBD<T extends AreaBDType> extends Object implements AreaXYSplitBDType<T>
An area that has been split into quadrants via an X and Y axis.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `AreaXYSplitBD.Builder<T extends AreaBDType>`
  Builds instances of type `AreaXYSplitBD`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static <T extends AreaBDType>
  AreaXYSplitBD.Builder<T>`
  `builder()`
  Creates a builder for `AreaXYSplitBD`.
  `static <T extends AreaBDType>
  AreaXYSplitBD<T>`
  `copyOf(AreaXYSplitBDType<T> instance)`
  Creates an immutable copy of a `AreaXYSplitBDType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `AreaXYSplitBD` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x0y0`, `x1y0`, `x0y1`, `x1y1`.
  `static <T extends AreaBDType>
  AreaXYSplitBD<T>`
  `of(T x0y0, T x1y0, T x0y1, T x1y1)`
  Construct a new immutable `AreaXYSplitBD` instance.
  `String`
  `toString()`
  Prints the immutable value `AreaXYSplitBD` with attribute values.
  `final AreaXYSplitBD<T>`
  `withX0y0(T value)`
  Copy the current immutable object by setting a value for the `x0y0` attribute.
  `final AreaXYSplitBD<T>`
  `withX0y1(T value)`
  Copy the current immutable object by setting a value for the `x0y1` attribute.
  `final AreaXYSplitBD<T>`
  `withX1y0(T value)`
  Copy the current immutable object by setting a value for the `x1y0` attribute.
  `final AreaXYSplitBD<T>`
  `withX1y1(T value)`
  Copy the current immutable object by setting a value for the `x1y1` attribute.
  `T`
  `x0y0()`
  `T`
  `x0y1()`
  `T`
  `x1y0()`
  `T`
  `x1y1()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x0y0

    public T x0y0()
    Specified by:
      `x0y0` in interface `AreaXYSplitBDType<T extends AreaBDType>`
    Returns:
      The minimum X, minimum Y quadrant

  - ### x1y0

    public T x1y0()
    Specified by:
      `x1y0` in interface `AreaXYSplitBDType<T extends AreaBDType>`
    Returns:
      The maximum X, minimum Y quadrant

  - ### x0y1

    public T x0y1()
    Specified by:
      `x0y1` in interface `AreaXYSplitBDType<T extends AreaBDType>`
    Returns:
      The minimum X, maximum Y quadrant

  - ### x1y1

    public T x1y1()
    Specified by:
      `x1y1` in interface `AreaXYSplitBDType<T extends AreaBDType>`
    Returns:
      The maximum X, maximum Y quadrant

  - ### withX0y0

    public final AreaXYSplitBD<T> withX0y0(T value)
    Copy the current immutable object by setting a value for the `x0y0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x0y0
    Returns:
      A modified copy of the `this` object

  - ### withX1y0

    public final AreaXYSplitBD<T> withX1y0(T value)
    Copy the current immutable object by setting a value for the `x1y0` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x1y0
    Returns:
      A modified copy of the `this` object

  - ### withX0y1

    public final AreaXYSplitBD<T> withX0y1(T value)
    Copy the current immutable object by setting a value for the `x0y1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x0y1
    Returns:
      A modified copy of the `this` object

  - ### withX1y1

    public final AreaXYSplitBD<T> withX1y1(T value)
    Copy the current immutable object by setting a value for the `x1y1` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x1y1
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `AreaXYSplitBD` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x0y0`, `x1y0`, `x0y1`, `x1y1`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `AreaXYSplitBD` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static <T extends AreaBDType> AreaXYSplitBD<T> of(T x0y0, T x1y0, T x0y1, T x1y1)
    Construct a new immutable `AreaXYSplitBD` instance.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `x0y0` - The value for the `x0y0` attribute
      `x1y0` - The value for the `x1y0` attribute
      `x0y1` - The value for the `x0y1` attribute
      `x1y1` - The value for the `x1y1` attribute
    Returns:
      An immutable AreaXYSplitBD instance

  - ### copyOf

    public static <T extends AreaBDType> AreaXYSplitBD<T> copyOf(AreaXYSplitBDType<T> instance)
    Creates an immutable copy of a `AreaXYSplitBDType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable AreaXYSplitBD instance

  - ### builder

    public static <T extends AreaBDType> AreaXYSplitBD.Builder<T> builder()
    Creates a builder for `AreaXYSplitBD`.

         AreaXYSplitBD.&lt;T&gt;builder()
            .setX0y0(T) // required x0y0
            .setX1y0(T) // required x1y0
            .setX0y1(T) // required x0y1
            .setX1y1(T) // required x1y1
            .build();

    Type Parameters:
      `T` - generic parameter T
    Returns:
      A new AreaXYSplitBD builder